package pbservice

import "errors"
import "fmt"
import "log"
import "math/rand"
import "net"
import "net/rpc"
import "os"
import "sync"
import "sync/atomic"
import "syscall"
import "time"
import "unsafe"
import "util"
import "viewservice"
import "strconv"

// Debugging
const Debug = 0


func DPrintf(format string, a ...interface{}) (n int, err error) {
	if Debug > 0 {
		n, err = fmt.Printf(format, a...)
	}
	return
}


/*
Each KV entry is stored in the form of this struct. Along with every value,
metadata is also stored. This metadata includes
	a) a lock to synchronize concurrent operations
	b) last put/get request id
*/
type KVEntry struct {
	// The value that is stored in the key value store.
	value string;
	previousValue string;
	// Any put/get request needs to acquire the lock before setting/getting the
	// value
	entryLock *sync.Mutex;
	// The request ID generated by the client.
	lastPutRequestID uint64;
	// lastRequestID from clerk
	lastRequestID uint64;
}

/*
This is not thread safe at all. Use with care. Purely for testing/debugging
purposes.
*/
func (kve *KVEntry) AsString() string {
	entry := fmt.Sprintf("Value: %s, PrevValue: %s, LastPutReqID: %d, LastReqID: %d",
		kve.value, kve.previousValue, kve.lastPutRequestID, kve.lastRequestID);
	return entry;
}


type PBServer struct {
	keyValueStore map[string]*KVEntry;
	currentView *viewservice.View;
	viewserviceAddress string;
	newKeyLock *sync.Mutex;

	// Variables to help chek if store shipment is complete.
	storeShipmentCompleteLock *sync.Mutex;
	storeShipmentComplete bool;

	// Variables to help check if store shipment is in progress i.e. has it
	// started.
	storeShipmentInProgress bool;
	storeShipmentInProgressLock *sync.Mutex;

	// Server declarations.
	l net.Listener;
  	dead bool; // for testing
  	unreliable bool; // for testing
  	me string;
  	done sync.WaitGroup;
  	finish chan interface{};
}

/*
Simply a helper function. This prints the entire key value store nicely. This
method is not thread safe at all and can also lead to seg faults.
Use this for only testing purposes.
*/
func (pb *PBServer) printKeyValueStore() {
	log.Printf("Key Value store: \n")
	for key, entry := range pb.keyValueStore {
		fmt.Printf("%s -> {%s}\n", key, entry.AsString())
	}
}

/*------------------------------------------------------------------------------
Private Methods.
------------------------------------------------------------------------------*/

/*
Call the viewserver with the current view number and return the reply view.
*/
func (pb *PBServer) pingViewServer() (*viewservice.View, error) {
	// Prepare the arguments.
	args := &viewservice.PingArgs{};
	args.Me = pb.me;
	currView := pb.getCurrentView();
	args.Viewnum = currView.Viewnum;
	var reply viewservice.PingReply;
	log.Printf("[%s][Ping] INFO: Pinging viewservice at %d with viewnum: %d",
		pb.me, (time.Now().UnixNano() / 1000000), args.Viewnum);
	// Send an RPC request and wait for the reply.
	ok := util.Call(pb.viewserviceAddress, "ViewServer.Ping", args, &reply);
	if ok == false {
		return &viewservice.View{}, errors.New(KViewServerPingError);
	}
	return &reply.View, nil;
}


/*
Atomically store a new pointer in the same location as the current view. Since
only the tick thread can modifiy the current view, this is fine. No races should
occur.
*/
func (pb *PBServer) setNewView(newView *viewservice.View) bool {
	atomic.StorePointer((*unsafe.Pointer)(unsafe.Pointer(&pb.currentView)),
		unsafe.Pointer(newView))
	return true;
}


/*
Atomically load the current view and return a pointer to the current view.
Since views can never be modified (just replaced/swapped) all threads can
concurrently use the same view without fear of race conditions.
*/
func (pb *PBServer) getCurrentView() *viewservice.View {
	currView := (*viewservice.View)(atomic.LoadPointer(
	(*unsafe.Pointer)(unsafe.Pointer(&pb.currentView))))
	return currView;
}


/*
Ping the viewserver periodically and get the current view.
*/
func (pb *PBServer) tick() {
	replyView, _ := pb.pingViewServer();
	currView := pb.getCurrentView();

	// We take action only when there is a view change
	if replyView.Viewnum != currView.Viewnum {
		// Sanity check. The new view number should not be lesser than the
		// view that we currently have.
		util.CHECK_LT((int)(currView.Viewnum), (int)(replyView.Viewnum),
			"Current view number is not lesser than new view number.");

		// Check if this is the first view. If so, set store shipment to complete.
		if (replyView.Viewnum == 1) && (currView.Viewnum == 0) && (replyView.Primary == pb.me) {
			pb.storeShipmentCompleteLock.Lock();
			defer pb.storeShipmentCompleteLock.Unlock();
			// Since this is the first view, the primary can assume that all
			// keys have already been shipped to it.
			pb.storeShipmentComplete = true;
			log.Printf("[%s][Tick] INFO: First ever view set with %s as primary.",
				pb.me, pb.me);
		} else if (currView.Backup == pb.me) && (replyView.Primary == pb.me) {
			// The server has been promoted from backup to primary. If the server
			// has still not received all the keys from the primary, reject
			// the view.
			if !pb.isStoreShipmentComplete() {
				log.Printf("[%s][Tick] CRITICAL: Promoted to primary even though store was not shipped completely from previous primary %s. Rejecting new view.",
					pb.me, currView.Primary);
				return
			}
		}

		// The view transition is safe. Set the current view as the reply view.
		pb.setNewView(replyView);
		prevView := currView;
		currView = pb.getCurrentView();

		// Check if the server has been promoted to backup. If so request a
		// store shipment of all the keys.
		if (prevView.Viewnum == 0) && (currView.Backup == pb.me) && (!pb.isStoreShipmentInProgress()) {
			log.Printf("[%s][Tick] INFO: Server has been promoted to backup. Requesting store shipment from primary %s",
				pb.me, currView.Primary);
			pb.initiateStoreShipment(currView);
		}
	}
}


/*------------------------------------------------------------------------------
Store shipment methods
------------------------------------------------------------------------------*/

/*
Check if store shipment is complete.
*/
func (pb *PBServer) isStoreShipmentComplete() bool {
	pb.storeShipmentCompleteLock.Lock();
	defer pb.storeShipmentCompleteLock.Unlock();
	return pb.storeShipmentComplete;
}


/*
Check if store shipment has been initiated.
*/
func (pb *PBServer) isStoreShipmentInProgress() bool {
	pb.storeShipmentInProgressLock.Lock();
	defer pb.storeShipmentInProgressLock.Unlock();
	return pb.storeShipmentInProgress;
}


/*
Request generated by backup to primary to ship the key value store.
*/
func (pb *PBServer) initiateStoreShipment(view *viewservice.View) {
	args := &StoreShipmentArgs{};
	var reply StoreShipmentReply;
	pb.storeShipmentInProgressLock.Lock();
	defer pb.storeShipmentInProgressLock.Unlock();
	log.Printf("[%s][RequestStore] INFO: Asking primary %s to ship store",
		pb.me, view.Primary);
	log.Printf("[%s][RequestStore] DEBUG: Acquired store-shipment-in-progress lock", pb.me)
	rpc_ok := util.Call(view.Primary, "PBServer.SendStore", args, &reply);
	i := 0;
	for i = 0; i < 7; i++ {
		if !rpc_ok {
			// This is an error. Either there could be a network issue/partition or
			// the backup may be down.
			log.Printf("[%s][RequestStore] ERROR: Unable to send RPC request to initiate store shipment from primary %s",
				pb.me, view.Primary);
		} else {

			pb.storeShipmentInProgress = true;
			break
		}
	}

	// Check if we exhausted the RPC attempts.
	if i == 7 {
		log.Printf("[%s][RequestStore] CRITICAL: Unable to request store shipment from primary %s even after %d RPC attempts. Giving up!",
			pb.me, view.Primary, i);
	}
	return
}


/*
Send the key value store to the backup. On successfully sending the store, send
a RPC to the backup indicating that the store shipment is complete. If there
was an error while shipping the store, give up store shipment.
*/
func (pb *PBServer) sendStore(view *viewservice.View) {
	log.Printf("[%s][SendStore] INFO: Started key value store shipment to backup %s",
		pb.me, view.Backup);
	for key, entry := range pb.keyValueStore {
		entry.entryLock.Lock();
		defer entry.entryLock.Unlock();
		log.Printf("[%s][SendStore] INFO: Acquired lock on entry for key[%s]",
			pb.me, key);
		backupArgs := GetBackupArgs{};
		backupArgs.Value = entry.value;
		backupArgs.Key = key;
		backupArgs.RequestID = entry.lastRequestID;
		backupArgs.PutRequestID = entry.lastPutRequestID;
		backupArgs.MyView = *view;
		var backupReply GetBackupReply;

		// Try 7 times and if it fails, give up!
		i := 0;
		for i = 0; i < 7; i++ {
			rpc_ok := util.Call(view.Backup, "PBServer.GetBackup", &backupArgs,
				&backupReply);
			if !rpc_ok {
				// This is an error. Either there could be a network issue/partition or
				// the backup may be down.
				log.Printf("[%s][SendStore] WARNING: Received an RPC error from backup %s. Attempts: %d.",
					pb.me, view.Backup, i);
				continue;
			}

			// Received an error message from the backup server.
			if backupReply.Err != KSuccess {
				log.Printf("[%s][SendStore] CRITICAL: Received %s from backup %s. Stopping store shipment.",
					pb.me, backupReply.Err, view.Backup);
				return
			}

			log.Printf("[%s][SendStore] INFO: Shipped key[%s] to backup %s",
				pb.me, key, view.Backup);
			break;
		}

		// Check if we have exhausted all our attempts at sending the key. If so,
		// stop store shipment.
		if i == 7 {
			log.Printf("[%s][SendStore] CRITICAL: Too many attempts trying to ship key[%s] to backup %s. Stopping store shipment.",
				pb.me, key, view.Backup);
			return
		}
	}

	// Let backup know that the store has been sent fully.
	args := &StoreShipmentArgs{};
	var reply StoreShipmentReply;
	iter := 0;
	for iter = 0; iter < 7; iter++ {
		scan_ok := util.Call(view.Backup, "PBServer.StoreShipmentComplete",
			args, &reply);
		if !scan_ok {
			log.Printf("[%s][SendStore] ERROR: Store shipment completed ACK to backup %s failed",
				pb.me, view.Backup);
		} else {
			log.Printf("[%s][SendStore] INFO: Store shipment completed ACK sent to backup %s.",
				pb.me, view.Backup);
			break;
		}
	}

	// Check if we have exhausted the number of attempts that we have to send
	// ACK to backup.
	if iter == 7 {
		log.Printf("[%s][SendStore] CRITICAL: Failed to send store-shipment-completed ACK to backup %s",
			pb.me, view.Backup);
	}
}


/*
Puts the value in the backup server.
*/
func (pb *PBServer) putBackup(backup string, key string, value string,
	pValue string, requestID uint64, putRequestID uint64,
	pView *viewservice.View, doHash bool) *PutBackupReply {

	backupArgs := &PutBackupArgs{};
	backupArgs.NewValue = value;
	backupArgs.PrevValue = pValue;
	backupArgs.Key = key;
	backupArgs.RequestID = requestID;
	// Since the key is not present in the primary, we assume that this
	// is the first put to this key.
	backupArgs.PutRequestID = putRequestID;
	backupArgs.PrimaryView = *pView;
	backupArgs.DoHash = doHash;
	backupReply := &PutBackupReply{};
	rpc_ok := util.Call(backup, "PBServer.PutBackup", backupArgs, backupReply);
	if !rpc_ok {
		backupReply.Err = KRemoteError;
		backupReply.PreviousValue = "";
	}
	return backupReply;
}

/*
Tell the server to suicide.
*/
func (pb *PBServer) kill() {
	pb.dead = true
	pb.l.Close()
}


/*------------------------------------------------------------------------------
Public RPC Methods.
------------------------------------------------------------------------------*/


/*
Puts the value in key value store.
*/
func (pb *PBServer) Put(args *PutArgs, reply *PutReply) error {

	// Check if it is the primary server. If not, reject the request.
	view := pb.getCurrentView();
	if view.Primary != pb.me {
		reply.Err = KErrWrongServer;
		reply.PreviousValue = "";
		log.Printf("ERROR:[Put] %s is not the primary server", pb.me);
		return nil;
	}

	log.Printf("[%s][Put] INFO: Processing Request %d for (%s -> %s). DoHash: %v",
		pb.me, args.RequestID, args.Key, args.Value, args.DoHash);

	_, ok :=  pb.keyValueStore[args.Key];
	// Check if the key value entry exists.
	if !ok {
		// Since key does not exist, avoid multiple threads trying
		// to insert the key at the same time. Take the newKeyLock before
		// inserting the key.
		pb.newKeyLock.Lock();
		defer pb.newKeyLock.Unlock();
		log.Printf("[%s][Put] INFO: Acquired new key lock for entry %s.", pb.me, args.Key);

		// Check again if the key is present.
		_, present := pb.keyValueStore[args.Key]
		if !present {
			previousValue := "";
			newValue := args.Value;
			if args.DoHash {
				newValue = strconv.Itoa(int(hash(previousValue + newValue)));
			}
			// Check if a backup exists.
			if view.Backup != "" {
				// First put the value in the backup. Iff the backup succeeds,
				// we will update the primary.
				// Since this is first put request, set last put requestID to 1.
				backupReply := pb.putBackup(view.Backup, args.Key, newValue,
					previousValue, args.RequestID, (uint64)(1), view, args.DoHash);
				if backupReply.Err != KSuccess {
					log.Printf("[%s][Put] ERROR: Received %s from backup %s. Rejecting request %d for (%s -> %s)",
						pb.me, backupReply.Err, view.Backup, args.Key, args.Value)
					reply.Err = KRemoteError;
					reply.PreviousValue = "";
					return nil;
				}
			}

			// Backup, if present, has been updated successfully. Update primary
			// now.
			newEntry := new(KVEntry);
			newEntry.value = newValue;
			newEntry.previousValue = previousValue;
			newEntry.lastPutRequestID = 1;
			newEntry.lastRequestID = args.RequestID;
			// Initialize the lock.
			newEntry.entryLock = new(sync.Mutex);
			newEntry.entryLock.Lock();
			defer newEntry.entryLock.Unlock();
			pb.keyValueStore[args.Key] = newEntry;
			// Send reply to primary.
			reply.PreviousValue = previousValue;
			reply.Err = KSuccess;
			log.Printf("[%s][Put] INFO: Processed Request %d by creating a new (%s -> %s) in store",
				pb.me, args.RequestID, args.Key, newValue);
			log.Printf("[%s][Put] DEBUG: Updated Entry: %s -> %s", pb.me,
				args.Key, newEntry.AsString());
			return nil;
		} else {
			// The key was created by the time the server could acquire the new
			// lock.
			log.Printf("[%s][Put] INFO: The key %s was already created by the time newlock was acquired.",
				pb.me, args.Key);
		}
	}

	// We are now sure that the value is present.
	entry, _ :=  pb.keyValueStore[args.Key];

	entry.entryLock.Lock();
	defer entry.entryLock.Unlock();
	log.Printf("[%s][Put] INFO: Acquired lock on entry %s", pb.me, args.Key);

	newPutRequestID := entry.lastPutRequestID + 1;
	newValue := args.Value;
	if args.DoHash {
		newValue = strconv.Itoa(int(hash(entry.value + newValue)));
	}

	if view.Backup != "" {
		// First put the value in the backup. Iff the backup succeeds,
		// we will update the primary.
		backupReply := pb.putBackup(view.Backup, args.Key, newValue,
			entry.value, args.RequestID, newPutRequestID, view,
			args.DoHash);
		if backupReply.Err != KSuccess {
			log.Printf("[%s][Put] ERROR: Received %s from backup %s. Rejecting request %d for (%s -> %s)",
				pb.me, backupReply.Err, view.Backup, args.RequestID,
				args.Key, args.Value);
			reply.Err = KRemoteError;
			reply.PreviousValue = "";
			return nil;
		}
	}

	if args.RequestID == entry.lastRequestID {
		// This request has already been processed. Return the previous value.
		reply.Err = KSuccess;
		reply.PreviousValue = entry.previousValue;
		return nil;
	}

	// Backup, if present, has acked the entry. Update primary.
	reply.PreviousValue = entry.value;
	entry.previousValue = entry.value;
	entry.value = newValue;
	entry.lastPutRequestID = newPutRequestID;
	entry.lastRequestID = args.RequestID;
	log.Printf("[%s][Put] INFO: Processed Request %d. Updated entry: (%s -> %s). Put Request ID: %d",
		pb.me, args.RequestID, args.Key, entry.value, newPutRequestID);
	log.Printf("[%s][Put] DEBUG: Updated Entry: %s -> %s", pb.me, args.Key,
		entry.AsString());
	reply.Err = KSuccess;
	return nil
}


/*
Puts the value in key value store.
*/
func (pb *PBServer) PutBackup(args *PutBackupArgs, reply *PutBackupReply) error {
	// Check if it is the backup server. If not, reject the request.
	view := pb.getCurrentView();
	if view.Backup != pb.me {
		reply.Err = KErrWrongServer;
		reply.PreviousValue = "";
		log.Printf("[%s][PutBackup] ERROR: %s is not the backup server",
			pb.me, pb.me);
		return nil;
	}

	// Check if the viewnums are the same. If not, reject the request.
	if args.PrimaryView.Viewnum != view.Viewnum {
		log.Printf("[%s][PutBackup] ERROR: The viewnums did not match. %s, %s",
			args.PrimaryView.AsString(), view.AsString());
		reply.PreviousValue = "";
		reply.Err = KRemoteError;
		return nil;
	}

	log.Printf("[%s][PutBackup] INFO: Processing request %d , put request %d for (%s -> %s). DoHash: %v",
		pb.me, args.RequestID, args.PutRequestID, args.Key, args.NewValue,
		args.DoHash);

	_, ok :=  pb.keyValueStore[args.Key];
	// Check if the key exists.
	if !ok {
		// Since key does not exist, avoid multiple threads trying
		// to insert the key at the same time. Take the newKeyLock before
		// inserting the key.
		pb.newKeyLock.Lock();
		defer pb.newKeyLock.Unlock();
		log.Printf("[%s][PutBackup] INFO: Acquired new key lock for entry %s.", pb.me, args.Key);

		_, present := pb.keyValueStore[args.Key];
		// Once again, check if key exists. The key might have been created
		// by the time the new lock was acquired.
		if !present {
			previousValue := "";
			// The key is not present. Insert the key in the map.
			newEntry := new(KVEntry);
			newEntry.value = args.NewValue;
			newEntry.previousValue = args.PrevValue;
			newEntry.lastPutRequestID = args.PutRequestID;
			newEntry.lastRequestID = args.RequestID;
			// Initialize the lock.
			newEntry.entryLock = new(sync.Mutex);
			newEntry.entryLock.Lock();
			defer newEntry.entryLock.Unlock();
			pb.keyValueStore[args.Key] = newEntry;

			// Send reply to primary.
			reply.PreviousValue = previousValue;
			reply.Err = KSuccess;
			log.Printf("[%s][PutBackup] INFO: Processed Request %d , put request %d by creating a new (%s -> %s) in store",
				pb.me, args.RequestID, newEntry.lastPutRequestID, args.Key,
				newEntry.value);
			log.Printf("[%s][PutBackup] DEBUG: Updated Entry: %s -> %s",
				pb.me, args.Key, newEntry.AsString());
			return nil;
		} else {
			log.Printf("[%s][PutBackup] INFO: The key %s was already created by the time newlock was acquired. Updating key.",
				pb.me, args.Key);
		}
	}

	// We are now sure that the value is present.
	entry, _ :=  pb.keyValueStore[args.Key];

	entry.entryLock.Lock();
	defer entry.entryLock.Unlock();
	log.Printf("[%s][PutBackup] INFO: Acquired lock on entry %s", pb.me, args.Key);

	if args.PutRequestID < entry.lastPutRequestID {
		reply.Err = KRemoteError;
		reply.PreviousValue = "";
		log.Printf("[%s][PutBackup] ERROR: Value in store is more recent. Put request %d. Store Put Request %d",
			pb.me, args.PutRequestID, entry.lastPutRequestID);
		return nil;
	}

	if args.RequestID == entry.lastRequestID {
		// This request has already been processed. Simply ACK it and send the
		// Previous value back.
		reply.Err = KSuccess;
		reply.PreviousValue = entry.previousValue;
		return nil;
	}

	entry.previousValue = args.PrevValue;
	entry.value = args.NewValue;
	entry.lastPutRequestID = args.PutRequestID;
	entry.lastRequestID = args.RequestID;
	log.Printf("[%s][PutBackup] INFO: Processed Request %d. Updated entry: (%s -> %s). Put Request ID: %d",
		pb.me, args.RequestID, args.Key, entry.value, entry.lastPutRequestID);
	log.Printf("[%s][PutBackup] DEBUG: Updated Entry: %s -> %s", pb.me,
		args.Key, entry.AsString());
	reply.Err = KSuccess;
	reply.PreviousValue = entry.previousValue;
	return nil;
}


/*
*/
func (pb *PBServer) Get(args *GetArgs, reply *GetReply) error {

	// Check if it is the primary server. If not, reject the request.
	view := pb.getCurrentView();
	if view.Primary != pb.me {
		reply.Err = KErrWrongServer;
		reply.Value = "";
		log.Printf("ERROR:[Get] %s is not the primary server", pb.me);
		return nil;
	}

	log.Printf("[%s][Get] INFO: Processing Request %d for key[%s]",
		pb.me, args.RequestID, args.Key);

	entry, ok :=  pb.keyValueStore[args.Key];
	// Key is not present.
	if !ok {
		reply.Err = KErrNoKey;
		reply.Value = "";
		log.Printf("[%s][Get] ERROR: Key[%s] is not present in the store.",
			pb.me, args.Key);
		return nil;
	}

	// Take a lock on the entry. Multiple threads can be accessing the same
	// entry simultaneously.
	entry.entryLock.Lock();
	defer entry.entryLock.Unlock();
	log.Printf("[%s][Get] INFO: Acquired lock on entry for key[%s]", pb.me,
		args.Key);

	// Check if there exists a backup. If no backup exists, update entry
	// metadata and return the current value
	if view.Backup == "" {
		reply.Err = KSuccess;
		reply.Value = entry.value;
		entry.lastRequestID = args.RequestID;
		log.Printf("[%s][Get] INFO: Request %d successful. Returning %s for key[%s].",
			pb.me, args.RequestID, reply.Value, args.Key)
		return nil;
	}

	// There is a backup server. Make a RPC to the backup and get value from
	// backup. In this case, we are only interested in the error message.
	// In case there was an error, like if the backup has a greater
	// viewnum than the primary or if the backup is down, then reject the
	// request.
	backupArgs := GetBackupArgs{};
	backupArgs.Value = entry.value;
	backupArgs.PrevValue = entry.previousValue;
	backupArgs.Key = args.Key;
	backupArgs.RequestID = args.RequestID;
	backupArgs.PutRequestID = entry.lastPutRequestID;
	backupArgs.MyView = *view;
	var backupReply GetBackupReply;
	rpc_ok := util.Call(view.Backup, "PBServer.GetBackup", &backupArgs,
		&backupReply);
	if !rpc_ok {
		// This is an error. Either there could be a network issue/partition or
		// the backup may be down. Either ways, reject the request.
		reply.Err = KRemoteError;
		reply.Value = "";
		return nil;
	}

	// Received an error message from the backup server. Reject the request.
	if backupReply.Err != KSuccess {
		reply.Err = KRemoteError;
		reply.Value = "";
		log.Printf("[%s][Get] ERROR: Request %d failed for key[%s] due to remote error %s",
			pb.me, args.RequestID, args.Key, backupReply.Err);
		return nil;
	}

	// A successful reply from the backup as well. Update thyself and return the
	// value to the client.
	reply.Err = KSuccess;
	reply.Value = entry.value;
	entry.lastRequestID = args.RequestID;
	log.Printf("[%s][Get] INFO: Request %d successful. Returning %s for key[%s].",
		pb.me, args.RequestID, reply.Value, args.Key)
  	return nil
}


/*
Get the value from the backup server. If the value does not exist or if the
value is stale, then update/fix the entry in the backup server as well.
This allows the backup to catch up very quickly with the primary.
*/
func (pb *PBServer) GetBackup(args *GetBackupArgs,
	reply *GetBackupReply) error {

	// Check if it is the backup server. If not, reject the request.
	view := pb.getCurrentView();
	if view.Backup != pb.me {
		reply.Err = KErrWrongServer;
		reply.Value = "";
		log.Printf("[%s][GetBackup] ERROR: %s is not the backup server",
			pb.me, pb.me);
		return nil;
	}

	// Check if the viewnums are the same. If not, reject the request.
	if args.MyView.Viewnum != view.Viewnum {
		log.Printf("[%s][GetBackup] ERROR: The viewnums did not match. %s, %s",
			args.MyView.AsString(), view.AsString());
		reply.Value = "";
		reply.Err = KRemoteError;
		return nil;
	}

	log.Printf("[%s][GetBackup] INFO: Processing request %d for key %s",
		pb.me, args.RequestID, args.Key);

	_, ok :=  pb.keyValueStore[args.Key];
	// Key is not present. Fix the store by updating it with the latest value.
	// Essentially, this is a read repair operation.
	if !ok {
		// Since key does not exist, avoid multiple threads trying
		// to insert the key at the same time. Take the newKeyLock before
		// inserting the key.
		pb.newKeyLock.Lock();
		defer pb.newKeyLock.Unlock();
		log.Printf("[%s][GetBackup] INFO: Acquired new key lock for entry %s.", pb.me, args.Key);

		_, present := pb.keyValueStore[args.Key]
		if !present {
			// The key is not present. Insert the key in the map.
			newEntry := new(KVEntry);
			newEntry.value = args.Value;
			newEntry.lastPutRequestID = args.PutRequestID;
			newEntry.lastRequestID = args.RequestID;
			// Initialize the lock.
			newEntry.entryLock = new(sync.Mutex);
			newEntry.entryLock.Lock();
			defer newEntry.entryLock.Unlock();
			pb.keyValueStore[args.Key] = newEntry;

			// Send reply to primary.
			reply.Value = newEntry.value;
			reply.Err = KSuccess;
			log.Printf("[%s][GetBackup] INFO: Processed Request %d by creating a new key %s in store",
				pb.me, args.RequestID, args.Key);
			return nil;
		} else {
			log.Printf("[%s][GetBackup] INFO: The key %s was already created by the time newlock was acquired.",
				pb.me, args.Key);
		}
	}

	// We know the key is present. Since we never remove keys, we do not need
	// to check if it exists.
	entry, _ :=  pb.keyValueStore[args.Key];

	entry.entryLock.Lock();
	defer entry.entryLock.Unlock();
	log.Printf("[%s][GetBackup] INFO: Acquired lock on entry for key %s",
		pb.me, args.Key)

	if entry.lastPutRequestID < args.PutRequestID {
		// The key value entry is stale. Repair it.
		entry.value = args.Value;
		entry.previousValue = args.PrevValue;
		entry.lastPutRequestID = args.PutRequestID;
		log.Printf("[%s][GetBackup] INFO: Repaired stale KV entry for key %s.",
			pb.me, args.Key);
	}

	entry.lastRequestID = args.RequestID;
	reply.Value = entry.value;
	reply.Err = KSuccess;
	log.Printf("[%s][GetBackup] INFO: Request %d successful. Returning %s for key %s",
		pb.me, args.RequestID, reply.Value, args.Key);
	return nil;
}


/*
Will be called by the backup after it has entered the view. Ranges over
the entire map and issues GetBackup calls. GetBackup calls are repair ops by
default. If the value is not present in the backup, it will be created or
updated(if stale).
*/
func (pb *PBServer) SendStore(args *StoreShipmentArgs,
	reply *StoreShipmentReply) error {
	view := pb.getCurrentView();
	// There is no need to look at the args just start shipping everything.
	go pb.sendStore(view);
	reply.Err = KSuccess;
	return nil;
}


/*
Called by the primary to indicate to the backup that store shipment
has been completed.
*/
func (pb *PBServer) StoreShipmentComplete(args *StoreShipmentArgs,
	reply *StoreShipmentReply) error {
	pb.storeShipmentCompleteLock.Lock();
	pb.storeShipmentComplete = true;
	pb.storeShipmentCompleteLock.Unlock();

	pb.storeShipmentInProgressLock.Lock();
	pb.storeShipmentInProgress = false;
	pb.storeShipmentInProgressLock.Unlock();
	reply.Err = KSuccess;
	return nil;
}


/*------------------------------------------------------------------------------
Global Methods
------------------------------------------------------------------------------*/
func StartServer(vshost string, me string) *PBServer {
  	pb := new(PBServer);
  	pb.me = me;
	currentView := &viewservice.View{0, "", ""};
	pb.currentView = currentView;
	pb.viewserviceAddress = vshost

  	pb.finish = make(chan interface{})
	// Initialize the key value store.
	pb.keyValueStore = make(map[string]*KVEntry);

	// Initialize the new lock.
	pb.newKeyLock = new(sync.Mutex);

	pb.storeShipmentComplete = false;
	pb.storeShipmentCompleteLock = new(sync.Mutex);
	pb.storeShipmentInProgress = false;
	pb.storeShipmentInProgressLock = new(sync.Mutex);

  	rpcs := rpc.NewServer();
  	rpcs.Register(pb);

  	os.Remove(pb.me);
  	l, e := net.Listen("unix", pb.me);
  	if e != nil {
    	log.Fatal("listen error: ", e);
  	}
  	pb.l = l;

  	// please do not change any of the following code,
  	// or do anything to subvert it.

  	go func() {
    	for pb.dead == false {
      		conn, err := pb.l.Accept()
      		if err == nil && pb.dead == false {
        		if pb.unreliable && (rand.Int63() % 1000) < 100 {
          		// discard the request.
          			conn.Close()
        		} else if pb.unreliable && (rand.Int63() % 1000) < 200 {
          			// process the request but force discard of reply.
          			c1 := conn.(*net.UnixConn)
          			f, _ := c1.File()
          			err := syscall.Shutdown(int(f.Fd()), syscall.SHUT_WR)
          			if err != nil {
            			fmt.Printf("shutdown: %v\n", err)
          			}
          			pb.done.Add(1)
          			go func() {
            			rpcs.ServeConn(conn)
            			pb.done.Done()
          			}()
        		} else {
          			pb.done.Add(1)
          			go func() {
            			rpcs.ServeConn(conn)
            			pb.done.Done()
          			}()
				}
      		} else if err == nil {
        		conn.Close()
      		}
      		if err != nil && pb.dead == false {
        		fmt.Printf("PBServer(%v) accept: %v\n", me, err.Error())
        		pb.kill()
      		}
		}
    	DPrintf("%s: wait until all request are done\n", pb.me)
    	pb.done.Wait()
    	// If you have an additional thread in your solution, you could
    	// have it read to the finish channel to hear when to terminate.
    	close(pb.finish)
  	}()

  	pb.done.Add(1)
	// Start the tick thread.
  	go func() {
    	for pb.dead == false {
      		pb.tick()
      		time.Sleep(viewservice.PingInterval)
    	}
    	pb.done.Done()
  	}()

  	return pb
}
